//=============================================================================
//
// file :        KChannelSwitch.h
//
// description : Include for the KChannelSwitch class.
//
// project :	Keithley Channel Switch system
//
// $Author: xavela $
//
// $Revision: 1.2 $
// $Date: 2012-05-15 10:06:44 $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source: /users/chaize/newsvn/cvsroot/Instrumentation/KChannelSwitch/src/KChannelSwitch.h,v $
// $Log: not supported by cvs2svn $
//
// copyleft :    Synchrotron SOLEIL 
//               L'Orme des merisiers - Saint Aubin
//		 BP48 - 91192 Gif sur Yvette
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _KCHANNELSWITCH_H
#define _KCHANNELSWITCH_H

#include <tango.h>
//using namespace Tango;
#include "K7001.hpp"
//- YAT/4TANGO
#include <yat4tango/DynamicAttributeManager.h>

/**
 * @author	$Author: xavela $
 * @version	$Revision: 1.2 $
 */

 //	Add your own constant definitions here.
 //-----------------------------------------------


namespace KChannelSwitch_ns
{

/**
 * Class Description:
 * Device which controls a channel switch system <Br>
 *	Supported model(s) : 7001 <Br>
 */

/*
 *	Device States Description:
*  Tango::FAULT :  No GPIB proxy available
*  Tango::ALARM :  Error detected
*  Tango::ON :     No error
 */


class KChannelSwitch: public Tango::Device_4Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attribute member data.
 */
//@{
		Tango::DevUShort	*attr_inputChannelNumber_read;
		Tango::DevUShort	attr_inputChannelNumber_write;
//@}

/**
 * @name Device properties
 * Device properties member data.
 */
//@{
/**
 *	GPIB device proxy name.
 */
	string	gpibDeviceName;
/**
 *	The number of slots connected in the Keithley Channel Switch System.
 */
	Tango::DevUShort	nbConnectedSlot;
//@}

/**
 *	@name Device properties
 *	Device property member data.
 */
//@{
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	KChannelSwitch(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	KChannelSwitch(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	KChannelSwitch(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one destructor is defined for this class */
//@{
/**
 * The object destructor.
 */	
	~KChannelSwitch() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method before execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name KChannelSwitch methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for inputChannelNumber acquisition result.
 */
	virtual void read_inputChannelNumber(Tango::Attribute &attr);
/**
 *	Write inputChannelNumber attribute values to hardware.
 */
	virtual void write_inputChannelNumber(Tango::WAttribute &attr);
/**
 *	Read/Write allowed for inputChannelNumber attribute.
 */
	virtual bool is_inputChannelNumber_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for CloseAllChannels command.
 */
	virtual bool is_CloseAllChannels_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for OpenAllChannels command.
 */
	virtual bool is_OpenAllChannels_allowed(const CORBA::Any &any);
/**
 * This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *	@return	State Code
 *	@exception DevFailed
 */
	virtual Tango::DevState	dev_state();
/**
 * Command to close all input channels.
 *	@exception DevFailed
 */
	void	close_all_channels();
/**
 * Command to open all input channels.
 *	@exception DevFailed
 */
	void	open_all_channels();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------

  //- Dyn attr mamnagement
  void create_dynamic_attribute();
  void read_slotNumber_callback(yat4tango::DynamicAttributeReadCallbackData& cbd);
  void write_slotNumber_callback(yat4tango::DynamicAttributeWriteCallbackData& cbd);
	
  //- yat Scalar Dynamic Attribute
	yat4tango::DynamicAttributeManager*      _dam;

  //- Save attribute name/value as a device property
  template <class T>
  void store_value_as_property(T value,std::string property_name);
  //- Restore attribute value stored in a device property
  void restore_saved_properties(void);

  AbstractKChannelSwitch * _kSwitch;
  
  //- memorized attribte(s) management
  unsigned short __memorizedSlotNumber;
  unsigned short __memorizedChannelNumber;
};

}	// namespace_ns

#endif	// _KCHANNELSWITCH_H
